#Reference: openpyxl documentation: https://openpyxl.readthedocs.io/en/stable/
#openpyxl tutorial Reference:       https://automatetheboringstuff.com/chapter12/
#Python Forum Reference:            https://python-forum.io/Thread-Identify-Hidden-rows-in-xls
import openpyxl

print("Read the VALUE and ROW VISIBILITY from cells A1:A6 in a .xlsx file from 'Sheet2'.")
print()

######################################################
# Access .xls file (Excel 2003 and before)
# NOTE: openpyxl DOES NOT support .xls files
excel_filename = "HiddenRow3OnSheet2.xls"
print("File: {} - .xls format is NOT SUPPORTED by 'openpyxl'.".format(excel_filename))
print()


######################################################
# Access .xlsx file (Excel 2007 and later)
excel_filename = "HiddenRow3OnSheet2.xlsx"

# Open the workbook
#NOTE: 'data_only=True' REQUIRED to get VALUES from cells that contain formulas
xl_workbook = openpyxl.load_workbook(excel_filename, data_only=True)

#Set the focus on 'Sheet2'
my_sheet_name = "Sheet2"
xl_sheet = xl_workbook[my_sheet_name]

print("File: {}".format(excel_filename))
for irow in range(1, xl_sheet.max_row + 1):
    ihidden = xl_sheet.row_dimensions[irow].hidden  #Row Visibility True / False
    if ihidden == True:
      shidden = "HIDDEN"
    else:
      shidden = "VISIBLE" 
    #
    svalue = xl_sheet.cell(irow, 1).value
    print("Value: {}        Row Visibility: {}".format(svalue, shidden))
