#Reference: xlrd manual: https://media.readthedocs.org/pdf/xlrd/latest/xlrd.pdf
#Python Forum Reference: https://python-forum.io/Thread-Identify-Hidden-rows-in-xls
import xlrd

print("Read the VALUE and ROW VISIBILITY from cells A1:A6 in a .xls file from 'Sheet2'.")
print()

######################################################
# Access .xls file (Excel 2003 and before)
excel_filename = "HiddenRow3OnSheet2.xls"

# Open the workbook
#NOTE: Traceback error if 'formatting_info=True' is NOT INCLUDED
xl_workbook = xlrd.open_workbook(excel_filename, formatting_info=True)

#Set the focus on 'Sheet2'
my_sheet_name = "Sheet2"
xl_sheet = xl_workbook.sheet_by_name(my_sheet_name)

print("File: {}".format(excel_filename))
for irow in range(xl_sheet.nrows):
    ihidden = xl_sheet.rowinfo_map[irow].hidden   #Row Visibility 0=Visible 1=Hidden
    if ihidden == True:
      shidden = "VISIBLE"
    else:
      shidden = "HIDDEN"
    #
    svalue = xl_sheet.cell(irow,0).value
    print("Value: {}        Row Visibility: {}".format(svalue, shidden))
    

######################################################
# Access .xlsx file (Excel 2007 and later)
excel_filename = "HiddenRow3OnSheet2.xlsx"

# Open the workbook
#NOTE: 'formatting_info=True' is NOT SUPPORTED for .xlsx files
xl_workbook = xlrd.open_workbook(excel_filename)

#Set the focus on 'Sheet2'
my_sheet_name = "Sheet2"
xl_sheet = xl_workbook.sheet_by_name(my_sheet_name)

print()
print("File: {}".format(excel_filename))
for irow in range(xl_sheet.nrows):
    svalue = xl_sheet.cell(irow,0).value
    print("Value: {}       Row Visibility: {}".format(svalue, "Not Available for .xlsx files"))